/* Copyright (C) |Meso|Star> 2015-2017 (contact@meso-star.com)
 *
 * This software is a computer program whose purpose is to describe a
 * virtual 3D environment that can be ray-traced and sampled both robustly
 * and efficiently.
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software. You can use,
 * modify and/or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty and the software's author, the holder of the
 * economic rights, and the successive licensors have only limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading, using, modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean that it is complicated to manipulate, and that also
 * therefore means that it is reserved for developers and experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and, more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms. */

#ifndef S3D_INSTANCE_H
#define S3D_INSTANCE_H

#include "s3d_geometry.h"
#include <rsys/dynamic_array.h>
#include <rsys/ref_count.h>

struct instance {
  float transform[12]; /* local to world 3x4 column major matrix */
  struct s3d_scene* scene; /* Instantiated scene */
  /* Current view of the instantiated scene. Note that the instance does not
   * own the scnview; the instance scnview lifetime is managed by the scnview
   * into which the instance lies */
  struct s3d_scene_view* scnview;
  ref_T ref;
};

extern LOCAL_SYM res_T
instance_create
  (struct s3d_scene* scene,
   struct instance** inst);

extern LOCAL_SYM void
instance_ref_get
  (struct instance* inst);

extern LOCAL_SYM void
instance_ref_put
  (struct instance* inst);

#endif /* S3D_INSTANCE_H */

